 #include <math.h>
/*
	* m						- number of points 
	* n						- number of dimensions
	* D						- matrix (m2xn) of distances, m2 - number of points n- number of dimensions
	* Corr			- correlation matrix (mxm).
	* Theta		- range parameters (n).
	*
	* called from CorrMatrix.sci
	*
	* scilab code:
	* 				ii=1;
					for i=1:m-1
							for j=i+1:m
										R(i,j)=funct(D(ii,:),model.theta);
										ii=ii+1;
								
							end;
					end;

					R=R+R';
					R=R+eye(R);

	*/

#include "corr_functions.h"

    double corr_D(double *D, double *Theta,int *m, int *m2, int *n,int *fun,double *Corr)
    {
									int i,j,ii,k;
									double tmp;
									ii=0;

//gaussian
									if (*fun==1) {
															for ( i=0; i<*m; i++)
															{
																				for (k=i+1; k<*m;k++)
																				{
																									Corr[i+k**m]=1;
																									for ( j=0; j<*n; j++)
																									{
																														Corr[i+k**m]=Corr[i+k**m]*gaussian(D[ii+j**m2],Theta[j]);// callculates gaussian covariance
																									}
																				ii++;
																				Corr[i**m+k]=Corr[i+k**m];
										
																				}
															Corr[i+i**m]=1;
															}
									}
// matern
									if (*fun==2) {
															for ( i=0; i<*m; i++)
															{
																				for (k=i+1; k<*m;k++)
																				{
																									Corr[i+k**m]=1;
																									for ( j=0; j<*n; j++)
																									{
																															tmp=D[ii+j**m2];
																															if (tmp <0) { tmp=-tmp;} 
																														Corr[i+k**m]=Corr[i+k**m]*matern_5_2(tmp,Theta[j]);
																												//Corr[i+k**m]=Corr[i+k**m]*gaussian(D[ii+j**m2],Theta[j]);
																											//	Corr[i+k**m]=Corr[i+k**m]*gaussian(D[ii+j**m2],Theta[j]);
																									}
																				ii++;
																				Corr[i**m+k]=Corr[i+k**m];
										
																				}
															Corr[i+i**m]=1;
															}
									}

				}

