 #include <math.h>
/*
	* m						- rows 
	* n						- columns
	* 	X					-matrix (mxn) of points , m - number of points n- number of dimensions
	* Corr			- correlation vector (m).
	* Theta		- range parameters (n).
	*
	*
	* Called form createCorr.sci;
	*
	*
	*Scilab code:
	*
	*
											for i=1:m-1
												for j=i+1:m
																	R(i,j)=fcov(X(i,:)-X(j,:),theta);
												end;
										end;
										R=R+R'+eye(R);
										end;
	*
	*
	*/
#include "corr_functions.h"
    double corr_X(double *X, double *Theta,int *m, int *n,int *fun, double *Corr)
    {
									int i,j,k;
										double tmp;
					//gaussian cov
							if (*fun==1) {
										for ( i=0; i<*m; i++)
										{
															for (k=i+1; k<*m;k++)
															{
																				Corr[i+k**m]=1;
																				for ( j=0; j<*n; j++)
																				{
																									Corr[i+k**m]=Corr[i+k**m]*gaussian(X[k+j**m]-X[i+j**m],Theta[j]);// callculates gaussian covariance
																								//	C=X[k**m+j];
																				}
															//Corr[i+k**m]=C;
															
															Corr[i**m+k]=Corr[i+k**m];
					
															}
										Corr[i+i**m]=1;
										}
							}

							// matern cov
							if (*fun==2) {
										for ( i=0; i<*m; i++)
										{
															for (k=i+1; k<*m;k++)
															{
																				Corr[i+k**m]=1;
																				for ( j=0; j<*n; j++)
																				{
																									//tmp=sqrt((X[k+j**m]-X[i+j**m])*(X[k+j**m]-X[i+j**m]));
																									tmp=X[k+j**m]-X[i+j**m];
																									if (tmp <0) { tmp=-tmp;} 
																									Corr[i+k**m]=Corr[i+k**m]*matern_5_2(tmp,Theta[j]);// callculates gaussian covariance
																								//	C=X[k**m+j];
																				}
															//Corr[i+k**m]=C;
															
															Corr[i**m+k]=Corr[i+k**m];
					
															}
										Corr[i+i**m]=1;
										}
							}

							}
